searchNodes=[{"ref":"ConnectFour.Game.html","title":"ConnectFour.Game","type":"module","doc":"A Connect Four game. Players are distinguished by game piece color (yellow and red). Moves are represented by the columns in which they are made. Yellow moves first. This implementation is based on an efficient implementation written by John Tromp, which uses bitboards to be very small and very fast. This is how it works: https://github.com/denkspuren/BitboardC4/blob/master/BitboardDesign.md Original Java implementation: https://tromp.github.io/c4/Connect4.java"},{"ref":"ConnectFour.Game.html#child_spec/1","title":"ConnectFour.Game.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ConnectFour.Game.html#legal_moves/1","title":"ConnectFour.Game.legal_moves/1","type":"function","doc":"Get a list of legal moves for the current position. Examples iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.legal_moves(pid) {:ok, [0, 1, 2, 3, 4, 5, 6]} iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.move(pid, [3, 3, 3, 3, 3, 3]) {:ok, %{moves: [3, 3, 3, 3, 3, 3], result: nil}} iex&gt; Game.legal_moves(pid) {:ok, [0, 1, 2, 4, 5, 6]}"},{"ref":"ConnectFour.Game.html#look/1","title":"ConnectFour.Game.look/1","type":"function","doc":"Look at the state of the game. Examples iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.move(pid, [4, 5, 4]) {:ok, %{moves: [4, 5, 4], result: nil}} iex&gt; Game.look(pid) {:ok, %{moves: [4, 5, 4], result: nil}} Works for finished games, too. Examples iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.move(pid, [4, 5, 4, 5, 4, 5]) {:ok, %{moves: [4, 5, 4, 5, 4, 5], result: nil}} iex&gt; Game.move(pid, 4) {:ok, %{moves: [4, 5, 4, 5, 4, 5, 4], result: :yellow_wins}} iex&gt; Game.look(pid) {:ok, %{moves: [4, 5, 4, 5, 4, 5, 4], result: :yellow_wins}}"},{"ref":"ConnectFour.Game.html#move/2","title":"ConnectFour.Game.move/2","type":"function","doc":"Submit a move for whomever&#39;s turn it currently is by specifying a column (0 through 6). Make multiple moves at once by passing a list of moves. If any of the moves are invalid, none (including any valid ones preceding the invalid one) will be played. moves is a list of all the moves completed in the game so far. Moves are represented as integers between 0 and 6, each reflecting the column in which the piece for that turn was dropped. The first integer in the list is yellow&#39;s move, the second is red&#39;s, the third is yellow&#39;s, and so on. Game results are reported as atoms and can be one of the following: nil (when the game is still in progress) :yellow_wins :red_wins :draw (when the board fills up without four connected pieces) Examples iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.move(pid, 4) {:ok, %{moves: [4], result: nil}} iex&gt; Game.move(pid, 5) {:ok, %{moves: [4, 5], result: nil}} iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.move(pid, [4, 5]) {:ok, %{moves: [4, 5], result: nil}} iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.move(pid, [4, 7]) {:error, &quot;One or more invalid moves&quot;} iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.move(pid, [1, 1, 2, 2, 3, 3, 4]) {:ok, %{moves: [1, 1, 2, 2, 3, 3, 4], result: :yellow_wins}} iex&gt; Game.move(pid, 4) {:error, &quot;Game is over&quot;}"},{"ref":"ConnectFour.Game.html#restart/1","title":"ConnectFour.Game.restart/1","type":"function","doc":"Restart the game. The game does not need to have a result to be restarted. Examples iex&gt; {:ok, pid} = Game.start_link() iex&gt; Game.move(pid, 4) {:ok, %{moves: [4], result: nil}} iex&gt; Game.restart(pid) :ok iex&gt; Game.move(pid, 4) {:ok, %{moves: [4], result: nil}}"},{"ref":"ConnectFour.Game.html#start_link/0","title":"ConnectFour.Game.start_link/0","type":"function","doc":"Start a GenServer process for a Connect Four game. Examples iex&gt; {:ok, pid} = Game.start_link() iex&gt; Process.alive?(pid) true"},{"ref":"ConnectFour.Game.html#t:column/0","title":"ConnectFour.Game.column/0","type":"type","doc":"One of seven Connect Four game columns."},{"ref":"ConnectFour.Game.html#t:moves/0","title":"ConnectFour.Game.moves/0","type":"type","doc":"A list of Connect Four moves, describing a game."},{"ref":"ConnectFour.Game.html#t:player/0","title":"ConnectFour.Game.player/0","type":"type","doc":"A Connect Four player (yellow always moves first)."},{"ref":"ConnectFour.Game.html#t:result/0","title":"ConnectFour.Game.result/0","type":"type","doc":"A Connect Four game result. nil means that the game has not yet ended. :draws occur when all columns are full and no player has connected four."},{"ref":"ConnectFour.Game.html#t:t/0","title":"ConnectFour.Game.t/0","type":"type","doc":""}]